Index: /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 10250)
+++ /branches/UKMO/dev_r5518_AMM15_package/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 10251)
@@ -4696,9 +4206,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015
-   !> - add interp, extrap, and filter argument
-   !> @date July, 2015
-   !> - add unit factor (to change unit)
+   !> - November, 2013- Initial Version
    !
    !> @param[in] cd_name         variable name
@@ -4730,9 +4236,4 @@
    !> deflation is in use
    !> @param[in] id_chunksz      chunk size
-   !> @param[in] cd_interp       interpolation method
-   !> @param[in] cd_extrap       extrapolation method
-   !> @param[in] cd_filter       filter method
-   !> @param[in] cd_unt          new units (linked to units factor)
-   !> @param[in] dd_unf          units factor
    !> @return variable structure
    !-------------------------------------------------------------------
@@ -4745,7 +4246,5 @@
    &                                    dd_min, dd_max,           &
    &                                    ld_contiguous, ld_shuffle,&
-   &                                    ld_fletcher32, id_deflvl, id_chunksz, &
-   &                                    cd_interp, cd_extrap, cd_filter, &
-   &                                    cd_unt, dd_unf)
+   &                                    ld_fletcher32, id_deflvl, id_chunksz)
 
       IMPLICIT NONE
@@ -4776,9 +4275,4 @@
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_deflvl
       INTEGER(i4)     , DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_chunksz
-      CHARACTER(LEN=*), DIMENSION(2)        , INTENT(IN), OPTIONAL :: cd_interp
-      CHARACTER(LEN=*), DIMENSION(1)        , INTENT(IN), OPTIONAL :: cd_extrap
-      CHARACTER(LEN=*), DIMENSION(5)        , INTENT(IN), OPTIONAL :: cd_filter
-      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_unt
-      REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_unf
 
       ! local variable
@@ -4827,9 +4321,5 @@
       &                         ld_fletcher32=ld_fletcher32,        &
       &                         id_deflvl=id_deflvl,                &
-      &                         id_chunksz=id_chunksz(:),           &
-      &                         cd_interp=cd_interp(:),             &
-      &                         cd_extrap=cd_extrap(:),             &
-      &                         cd_filter=cd_filter(:),             &
-      &                         cd_unt=cd_unt, dd_unf=dd_unf)
+      &                         id_chunksz=id_chunksz(:))
       
       DEALLOCATE( dl_value )
@@ -4853,9 +4343,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015
-   !> - add interp, extrap, and filter argument
-   !> @date July, 2015
-   !> - add unit factor (to change unit)
+   !> - November, 2013- Initial Version
    !
    !> @param[in] cd_name         variable name
@@ -4887,9 +4373,4 @@
    !> deflation is in use
    !> @param[in] id_chunksz      chunk size
-   !> @param[in] cd_interp       interpolation method
-   !> @param[in] cd_extrap       extrapolation method
-   !> @param[in] cd_filter       filter method
-   !> @param[in] cd_unt          new units (linked to units factor)
-   !> @param[in] dd_unf          units factor
    !> @return variable structure
    !-------------------------------------------------------------------
@@ -4902,7 +4383,5 @@
    &                                 dd_min, dd_max,           &
    &                                 ld_contiguous, ld_shuffle,&
-   &                                 ld_fletcher32, id_deflvl, id_chunksz, &
-   &                                 cd_interp, cd_extrap, cd_filter, &
-   &                                 cd_unt, dd_unf)
+   &                                 ld_fletcher32, id_deflvl, id_chunksz)
 
       IMPLICIT NONE
@@ -4933,9 +4412,4 @@
       INTEGER(i4)     ,                       INTENT(IN), OPTIONAL :: id_deflvl
       INTEGER(i4)     , DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_chunksz
-      CHARACTER(LEN=*), DIMENSION(2)        , INTENT(IN), OPTIONAL :: cd_interp
-      CHARACTER(LEN=*), DIMENSION(1)        , INTENT(IN), OPTIONAL :: cd_extrap
-      CHARACTER(LEN=*), DIMENSION(5)        , INTENT(IN), OPTIONAL :: cd_filter
-      CHARACTER(LEN=*),                       INTENT(IN), OPTIONAL :: cd_unt
-      REAL(dp)        ,                       INTENT(IN), OPTIONAL :: dd_unf
 
       ! local variable
@@ -4985,9 +4459,5 @@
       &                      ld_fletcher32=ld_fletcher32,        &
       &                      id_deflvl=id_deflvl,                &
-      &                      id_chunksz=id_chunksz(:),           &
-      &                      cd_interp=cd_interp(:),             &
-      &                      cd_extrap=cd_extrap(:),             &
-      &                      cd_filter=cd_filter(:),             &
-      &                      cd_unt=cd_unt, dd_unf=dd_unf)
+      &                      id_chunksz=id_chunksz(:))
       
       DEALLOCATE( dl_value )
@@ -5003,5 +4473,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var1   variable structure
@@ -5053,5 +4523,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var1   variable structure
@@ -5125,5 +4595,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var1   variable structure
@@ -5200,5 +4670,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var1   variable structure
@@ -5275,5 +4745,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var1   variable structure
@@ -5350,7 +4820,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015 
-   !> - add all element of the array in the same time
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_var variable structure
@@ -5365,7 +4833,4 @@
       ! local variable
       INTEGER(i4) :: il_natt
-      INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_ind
-      TYPE(TATT), DIMENSION(:), ALLOCATABLE :: tl_att
 
       ! loop indices
@@ -5375,103 +4840,7 @@
       il_natt=SIZE(td_att(:))
 
-      IF( td_var%i_natt > 0 )THEN
-      ! already other attribute in variable structure
-         ALLOCATE( tl_att(td_var%i_natt), stat=il_status )
-         IF(il_status /= 0 )THEN
-
-            CALL logger_error( &
-            &  " VAR ADD ATT: not enough space to put attributes from "//&
-            &  TRIM(td_var%c_name)//" in temporary attribute structure")
-
-         ELSE
-
-            ! save temporary global attribute's variable structure
-            tl_att(:)=att_copy(td_var%t_att(:))
-
-            CALL att_clean(td_var%t_att(:))
-            DEALLOCATE( td_var%t_att )
-            ALLOCATE( td_var%t_att(td_var%i_natt+il_natt), stat=il_status )
-            IF(il_status /= 0 )THEN
-
-               CALL logger_error( &
-               &  " VAR ADD ATT: not enough space to put attributes "//&
-               &  "in variable structure "//TRIM(td_var%c_name) )
-
-            ENDIF
-
-            ! copy attribute in variable before
-            td_var%t_att(1:td_var%i_natt)=att_copy(tl_att(:))
-
-            ! clean
-            CALL att_clean(tl_att(:))
-            DEALLOCATE(tl_att)
-            
-         ENDIF
-      ELSE
-      ! no attribute in variable structure
-         IF( ASSOCIATED(td_var%t_att) )THEN
-            CALL att_clean(td_var%t_att(:))
-            DEALLOCATE(td_var%t_att)
-         ENDIF
-         ALLOCATE( td_var%t_att(td_var%i_natt+il_natt), stat=il_status )
-         IF(il_status /= 0 )THEN
-
-            CALL logger_error( &
-            &  " VAR ADD ATT: not enough space to put attributes "//&
-            &  "in variable structure "//TRIM(td_var%c_name) )
-
-         ENDIF
-      ENDIF
-
-      ALLOCATE( tl_att(il_natt) )
-      tl_att(:)=att_copy(td_att(:))
-
-      ! check if attribute already in variable structure
       DO ji=1,il_natt
-         il_ind=0
-         il_ind=att_get_index( td_var%t_att(:), tl_att(ji)%c_name )
-         IF( il_ind /= 0 )THEN
-            CALL logger_error( &
-            &  " VAR ADD ATT: attribute "//TRIM(tl_att(ji)%c_name)//&
-            &  ", already in variable "//TRIM(td_var%c_name) )
-            CALL att_clean(tl_att(ji))
-         ENDIF
+         CALL var_add_att(td_var, td_att(ji))
       ENDDO
-
-      ! add new attributes
-      td_var%t_att(td_var%i_natt+1:td_var%i_natt+il_natt)=att_copy(tl_att(:))
-
-      DEALLOCATE(tl_att)
-
-      DO ji=1,il_natt
-         ! highlight some attribute
-         IF( ASSOCIATED(td_var%t_att(td_var%i_natt+ji)%d_value) .OR. &
-           & td_var%t_att(td_var%i_natt+ji)%c_value /= 'none' )THEN
-            SELECT CASE(TRIM(td_var%t_att(td_var%i_natt+ji)%c_name))
-
-               CASE("add_offset")
-                  td_var%d_ofs = td_var%t_att(td_var%i_natt+ji)%d_value(1)
-               CASE("scale_factor")
-                  td_var%d_scf = td_var%t_att(td_var%i_natt+ji)%d_value(1)
-               CASE("_FillValue")
-                  td_var%d_fill = td_var%t_att(td_var%i_natt+ji)%d_value(1)
-               CASE("ew_overlap")
-                  td_var%i_ew = INT(td_var%t_att(td_var%i_natt+ji)%d_value(1),i4) 
-               CASE("standard_name")
-                  td_var%c_stdname = TRIM(td_var%t_att(td_var%i_natt+ji)%c_value)
-               CASE("long_name")
-                  td_var%c_longname = TRIM(td_var%t_att(td_var%i_natt+ji)%c_value)
-               CASE("units")
-                  td_var%c_units = TRIM(td_var%t_att(td_var%i_natt+ji)%c_value)
-               CASE("grid_point")
-                  td_var%c_point = TRIM(td_var%t_att(td_var%i_natt+ji)%c_value)
-
-            END SELECT
-         ENDIF
-      ENDDO
-
-      ! update number of attribute
-      td_var%i_natt=td_var%i_natt+il_natt
-
 
    END SUBROUTINE var__add_att_arr
@@ -5481,7 +4850,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015 
-   !> - use var__add_att_arr subroutine
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5495,14 +4862,117 @@
 
       ! local variable
-      TYPE(TATT), DIMENSION(1) :: tl_att
+      INTEGER(i4) :: il_status
+      INTEGER(i4) :: il_ind
+      TYPE(TATT), DIMENSION(:), ALLOCATABLE :: tl_att
 
       ! loop indices
+      INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
-      ! copy structure in an array
-      tl_att(1)=att_copy(td_att)
-
-      ! 
-      CALL var_add_att( td_var, tl_att(:) )
+      ! check if attribute already in variable structure
+      il_ind=0
+      IF( ASSOCIATED(td_var%t_att) )THEN
+         il_ind=att_get_index( td_var%t_att(:), td_att%c_name )
+      ENDIF
+
+      IF( il_ind /= 0 )THEN
+
+         CALL logger_error( &
+         &  " VAR ADD ATT: attribute "//TRIM(td_att%c_name)//&
+         &  ", already in variable "//TRIM(td_var%c_name) )
+
+         DO ji=1,td_var%i_natt
+            CALL logger_debug( &
+            &  " VAR ADD ATT: in variable "//TRIM(td_var%t_att(ji)%c_name) )
+         ENDDO
+
+      ELSE
+         
+         CALL logger_trace( &
+         &  " VAR ADD ATT: add attribute "//TRIM(td_att%c_name)//&
+         &  ", in variable "//TRIM(td_var%c_name) )
+
+         IF( td_var%i_natt > 0 )THEN
+         ! already other attribute in variable structure
+            ALLOCATE( tl_att(td_var%i_natt), stat=il_status )
+            IF(il_status /= 0 )THEN
+
+               CALL logger_error( &
+               &  " VAR ADD ATT: not enough space to put attributes from "//&
+               &  TRIM(td_var%c_name)//" in temporary attribute structure")
+
+            ELSE
+
+               ! save temporary global attribute's variable structure
+               tl_att(:)=att_copy(td_var%t_att(:))
+
+               CALL att_clean(td_var%t_att(:))
+               DEALLOCATE( td_var%t_att )
+               ALLOCATE( td_var%t_att(td_var%i_natt+1), stat=il_status )
+               IF(il_status /= 0 )THEN
+
+                  CALL logger_error( &
+                  &  " VAR ADD ATT: not enough space to put attributes "//&
+                  &  "in variable structure "//TRIM(td_var%c_name) )
+
+               ENDIF
+
+               ! copy attribute in variable before
+               td_var%t_att(1:td_var%i_natt)=att_copy(tl_att(:))
+
+               ! clean
+               CALL att_clean(tl_att(:))
+               DEALLOCATE(tl_att)
+               
+            ENDIF
+         ELSE
+         ! no attribute in variable structure
+            IF( ASSOCIATED(td_var%t_att) )THEN
+               CALL att_clean(td_var%t_att(:))
+               DEALLOCATE(td_var%t_att)
+            ENDIF
+            ALLOCATE( td_var%t_att(td_var%i_natt+1), stat=il_status )
+            IF(il_status /= 0 )THEN
+
+               CALL logger_error( &
+               &  " VAR ADD ATT: not enough space to put attributes "//&
+               &  "in variable structure "//TRIM(td_var%c_name) )
+
+            ENDIF
+         ENDIF
+         ! update number of attribute
+         td_var%i_natt=td_var%i_natt+1
+
+         ! add new attribute
+         td_var%t_att(td_var%i_natt)=att_copy(td_att)
+
+         !! add new attribute id
+         !td_var%t_att(td_var%i_natt)%i_id=att_get_unit(td_var%t_att(:))
+
+         ! highlight some attribute
+         IF( ASSOCIATED(td_var%t_att(td_var%i_natt)%d_value) .OR. &
+           & td_var%t_att(td_var%i_natt)%c_value /= "none" )THEN
+            SELECT CASE(TRIM(td_var%t_att(td_var%i_natt)%c_name))
+
+               CASE("add_offset")
+                  td_var%d_ofs = td_var%t_att(td_var%i_natt)%d_value(1)
+               CASE("scale_factor")
+                  td_var%d_scf = td_var%t_att(td_var%i_natt)%d_value(1)
+               CASE("_FillValue")
+                  td_var%d_fill = td_var%t_att(td_var%i_natt)%d_value(1)
+               CASE("ew_overlap")
+                  td_var%i_ew = INT(td_var%t_att(td_var%i_natt)%d_value(1),i4) 
+               CASE("standard_name")
+                  td_var%c_stdname = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+               CASE("long_name")
+                  td_var%c_longname = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+               CASE("units")
+                  td_var%c_units = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+               CASE("grid_point")
+                  td_var%c_point = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+
+            END SELECT
+         ENDIF
+      ENDIF
 
    END SUBROUTINE var__add_att_unit
@@ -5512,8 +4982,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date February, 2015 
-   !> - define local attribute structure to avoid mistake 
-   !> with pointer
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5529,5 +4996,4 @@
       INTEGER(i4) :: il_ind
 
-      TYPE(TATT)  :: tl_att
       ! loop indices
       !----------------------------------------------------------------
@@ -5541,5 +5007,5 @@
       IF( il_ind == 0 )THEN
 
-         CALL logger_debug( &
+         CALL logger_warn( &
          &  " VAR DEL ATT: no attribute "//TRIM(cd_name)//&
          &  ", in variable "//TRIM(td_var%c_name) )
@@ -5547,6 +5013,5 @@
       ELSE
          
-         tl_att=att_copy(td_var%t_att(il_ind))
-         CALL var_del_att(td_var, tl_att)
+         CALL var_del_att(td_var, td_var%t_att(il_ind))
 
       ENDIF
@@ -5558,8 +5023,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013- Initial Version
-   !> @date February, 2015 
-   !> - delete highlight attribute too, when attribute 
-   !> is deleted
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5578,4 +5040,5 @@
 
       ! loop indices
+      !INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
@@ -5588,5 +5051,5 @@
       IF( il_ind == 0 )THEN
 
-         CALL logger_debug( &
+         CALL logger_warn( &
          &  " VAR DEL ATT: no attribute "//TRIM(td_att%c_name)//&
          &  ", in variable "//TRIM(td_var%c_name) )
@@ -5640,4 +5103,9 @@
                td_var%t_att(1:td_var%i_natt)=att_copy(tl_att(:))
 
+               !! change attribute id
+               !DO ji=1,td_var%i_natt
+               !   td_var%t_att(ji)%i_id=ji
+               !ENDDO
+
                ! clean
                CALL att_clean(tl_att(:))
@@ -5645,27 +5113,4 @@
             ENDIF 
          ENDIF
-
-         ! highlight attribute
-         SELECT CASE( TRIM(td_att%c_name) )
-
-            CASE("add_offset")
-               td_var%d_ofs = 0._dp
-            CASE("scale_factor")
-               td_var%d_scf = 1._dp
-            CASE("_FillValue")
-               td_var%d_fill = 0._dp
-            CASE("ew_overlap")
-               td_var%i_ew = -1 
-            CASE("standard_name")
-               td_var%c_stdname = ''
-            CASE("long_name")
-               td_var%c_longname = ''
-            CASE("units")
-               td_var%c_units = ''
-            CASE("grid_point")
-               td_var%c_point = ''
-
-         END SELECT
-
       ENDIF
 
@@ -5676,5 +5121,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5711,5 +5156,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5750,5 +5195,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5766,5 +5211,5 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_ndim <= ip_maxdim )THEN
+      IF( td_var%i_ndim <= 4 )THEN
 
          ! check if dimension already used in variable structure
@@ -5782,7 +5227,6 @@
          ELSE
 
-            ! back to disorder dimension array 
-            CALL dim_disorder(td_var%t_dim(:))
-
+         ! back to unorder dimension array 
+         CALL dim_unorder(td_var%t_dim(:))
             ! add new dimension
             td_var%t_dim(td_var%i_ndim+1)=dim_copy(td_dim)
@@ -5809,5 +5253,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5828,5 +5272,5 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_ndim <= ip_maxdim )THEN
+      IF( td_var%i_ndim <= 4 )THEN
 
          CALL logger_trace( &
@@ -5873,5 +5317,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -5916,5 +5360,5 @@
    !>
    !> @author J.Paul
-   !> @date June, 2014 - Initial Version
+   !> - June, 2014- Initial Version
    !
    !> @param[in] td_var array of variables structure
@@ -5942,5 +5386,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var    variable structure
@@ -6049,5 +5493,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_var variable structure
@@ -6187,5 +5631,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_var variable structure
@@ -6241,5 +5685,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -6317,5 +5761,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variabele structure
@@ -6393,5 +5837,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variabele structure
@@ -6469,5 +5913,5 @@
    !
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variabele structure
@@ -6543,5 +5987,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -6613,5 +6057,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_var variable structure
@@ -6636,5 +6080,5 @@
    !>
    !> @author J.Paul
-   !> @date September, 2014 - Initial Version
+   !> - September, 2014- Initial Version
    !>
    !> @param[in] td_var       array of variable structure
@@ -6701,5 +6145,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var       array of variable structure
@@ -6756,5 +6200,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[in] td_var array of variable structure
@@ -6795,5 +6239,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var array of variable structure
@@ -6878,7 +6322,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015 
-   !> - new namelist format to get extra information (interpolation,...)
+   !> - November, 2013- Initial Version
    !
    !> @param[in] cd_file   configuration file of variable
@@ -6915,4 +6357,5 @@
 
          il_fileid=fct_getunit()
+         CALL logger_trace("VAR DEF EXTRA: open "//TRIM(cd_file))
          OPEN( il_fileid, FILE=TRIM(cd_file), &
          &                FORM='FORMATTED',   &
@@ -6923,6 +6366,5 @@
          CALL fct_err(il_status)
          IF( il_status /= 0 )THEN
-            CALL logger_fatal("VAR DEF EXTRA: can not open file "//&
-            &                 TRIM(cd_file))
+            CALL logger_error("VAR DEF EXTRA: opening file "//TRIM(cd_file))
          ENDIF
 
@@ -6933,5 +6375,5 @@
          DO WHILE( il_status == 0 )
 
-         ! search line not beginning with comment character
+         ! search line do not beginning with comment character
             IF( SCAN( TRIM(fct_concat(cp_com(:))) ,cl_line(1:1)) == 0 )THEN
                il_nvar=il_nvar+1
@@ -6977,14 +6419,13 @@
                   tg_varextra(ji)%c_axis    =TRIM(fct_split(cl_line,3))
                   tg_varextra(ji)%c_point   =TRIM(fct_split(cl_line,4))
-
-                  cl_interp='int='//TRIM(fct_split(cl_line,5))
+                  tg_varextra(ji)%c_stdname =TRIM(fct_split(cl_line,5))
+                  tg_varextra(ji)%c_longname=TRIM(fct_split(cl_line,6))
+
+                  cl_interp=TRIM(fct_split(cl_line,7))
                   tg_varextra(ji)%c_interp(:) = &
                   &  var__get_interp(TRIM(tg_varextra(ji)%c_name), cl_interp)
                   CALL logger_debug("VAR DEF EXTRA: "//&
                   &  TRIM(tg_varextra(ji)%c_name)//&
-                  &  " "//TRIM(tg_varextra(ji)%c_interp(1)))
-
-                  tg_varextra(ji)%c_longname=TRIM(fct_split(cl_line,6))
-                  tg_varextra(ji)%c_stdname =TRIM(fct_split(cl_line,7))
+                  &  " "//TRIM(cl_interp))
                ELSE
                   ji=ji-1
@@ -7017,5 +6458,5 @@
    !> @details 
    !> string character format must be : <br/>
-   !> "varname:int=interp; flt=filter; ext=extrap; min=min; max=max"<br/>
+   !> "varname:interp; filter; extrap; > min; < max"<br/>
    !> you could specify only interpolation, filter or extrapolation method, 
    !> whatever the order. you could find more
@@ -7023,10 +6464,6 @@
    !> \ref extrap module.<br/>
    !> Examples: 
-   !> cn_varinfo='Bathymetry:flt=2*hamming(2,3); min=10.'
-   !> cn_varinfo='votemper:int=cubic; ext=dist_weight; max=40.'
-   !>
-   !>
-   !> @warning variable should be define in tg_varextra (ie in configuration
-   !> file, to be able to add information from namelist
+   !> cn_varinfo='Bathymetry:2*hamming(2,3); > 10.'
+   !> cn_varinfo='votemper:cubic; dist_weight; <40.'
    !>
    !> @note If you do not specify a method which is required, default one is
@@ -7034,7 +6471,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date July, 2015 
-   !> - get unit and unit factor (to change unit) 
+   !> - November, 2013- Initial Version
    !
    !> @param[in] cd_varinfo   variable information from namelist
@@ -7051,5 +6486,4 @@
       CHARACTER(LEN=lc), DIMENSION(1)              :: cl_extrap
       CHARACTER(LEN=lc), DIMENSION(5)              :: cl_filter
-      CHARACTER(LEN=lc)                            :: cl_unt
 
       INTEGER(i4)                                  :: il_ind
@@ -7058,5 +6492,4 @@
       REAL(dp)                                     :: dl_min
       REAL(dp)                                     :: dl_max
-      REAL(dp)                                     :: dl_unf
 
       TYPE(TVAR)       , DIMENSION(:), ALLOCATABLE :: tl_varextra
@@ -7075,10 +6508,7 @@
             dl_min=var__get_min(cl_name, cl_method)
             dl_max=var__get_max(cl_name, cl_method)
-            dl_unf=var__get_unf(cl_name, cl_method)
             cl_interp(:)=var__get_interp(cl_name, cl_method)
             cl_extrap(:)=var__get_extrap(cl_name, cl_method)
             cl_filter(:)=var__get_filter(cl_name, cl_method)
-            cl_unt=var__get_unt(cl_name, cl_method)
-
 
             il_ind=var_get_index(tg_varextra(:), TRIM(cl_name))
@@ -7086,6 +6516,4 @@
                IF( dl_min /= dp_fill ) tg_varextra(il_ind)%d_min=dl_min
                IF( dl_max /= dp_fill ) tg_varextra(il_ind)%d_max=dl_max
-               IF( dl_unf /= dp_fill ) tg_varextra(il_ind)%d_unf=dl_unf
-               IF(cl_unt      /='') tg_varextra(il_ind)%c_unt      =cl_unt
                IF(cl_interp(1)/='') tg_varextra(il_ind)%c_interp(:)=cl_interp(:)
                IF(cl_extrap(1)/='') tg_varextra(il_ind)%c_extrap(:)=cl_extrap(:)
@@ -7123,34 +6551,24 @@
                &                               cd_filter=cl_filter(:), &
                &                               dd_min = dl_min, &
-               &                               dd_max = dl_max, &
-               &                               cd_unt = cl_unt, &
-               &                               dd_unf = dl_unf )
+               &                               dd_max = dl_max )
 
             ENDIF
 
             ji=ji+1
-            CALL logger_debug( "VAR CHG EXTRA: name       "//&
+            CALL logger_trace( "VAR CHG EXTRA: name       "//&
             &                  TRIM(tg_varextra(il_ind)%c_name) )
-            CALL logger_debug( "VAR CHG EXTRA: interp     "//&
+            CALL logger_trace( "VAR CHG EXTRA: interp     "//&
             &                  TRIM(tg_varextra(il_ind)%c_interp(1)) )         
-            CALL logger_debug( "VAR CHG EXTRA: filter     "//&
+            CALL logger_trace( "VAR CHG EXTRA: filter     "//&
             &                  TRIM(tg_varextra(il_ind)%c_filter(1)) )         
-            CALL logger_debug( "VAR CHG EXTRA: extrap     "//&
+            CALL logger_trace( "VAR CHG EXTRA: extrap     "//&
             &                  TRIM(tg_varextra(il_ind)%c_extrap(1)) )
             IF( tg_varextra(il_ind)%d_min /= dp_fill )THEN
-               CALL logger_debug( "VAR CHG EXTRA: min value  "//&
+               CALL logger_trace( "VAR CHG EXTRA: min value  "//&
                &                  TRIM(fct_str(tg_varextra(il_ind)%d_min)) )
             ENDIF
             IF( tg_varextra(il_ind)%d_max /= dp_fill )THEN
-               CALL logger_debug( "VAR CHG EXTRA: max value  "//&
+               CALL logger_trace( "VAR CHG EXTRA: max value  "//&
                &                  TRIM(fct_str(tg_varextra(il_ind)%d_max)) )
-            ENDIF
-            IF( TRIM(tg_varextra(il_ind)%c_unt) /= '' )THEN
-               CALL logger_debug( "VAR CHG EXTRA: new unit  "//&
-               &                  TRIM(tg_varextra(il_ind)%c_unt) )
-            ENDIF
-            IF( tg_varextra(il_ind)%d_unf /= 1. )THEN
-               CALL logger_debug( "VAR CHG EXTRA: new unit factor  "//&
-               &                  TRIM(fct_str(tg_varextra(il_ind)%d_unf)) )
             ENDIF
          ENDDO
@@ -7175,5 +6593,5 @@
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !
    !> @param[inout] td_var variable structure
@@ -7269,5 +6687,5 @@
    !> 
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
+   !> - November, 2013- Initial Version
    !>
    !> @param[inout] td_var variable structure
@@ -7390,16 +6808,13 @@
             ENDIF
 
-            ! unt
-            IF( TRIM(td_var%c_unt) == '' .AND. &
-            &   TRIM(tg_varextra(il_ind)%c_unt) /= '' )THEN
-               td_var%c_unt=TRIM(tg_varextra(il_ind)%c_unt)
-            ENDIF
-
-            ! units factor
-            IF( td_var%d_unf == 1._dp .AND. &
-            &   tg_varextra(il_ind)%d_unf /= 1._dp )THEN
-               td_var%d_unf=tg_varextra(il_ind)%d_unf
-            ENDIF
-
+         CALL logger_trace("VAR GET EXTRA: name       "//TRIM(td_var%c_name))
+         CALL logger_trace("VAR GET EXTRA: stdname    "//TRIM(td_var%c_stdname))
+         CALL logger_trace("VAR GET EXTRA: longname   "//TRIM(td_var%c_longname))
+         CALL logger_trace("VAR GET EXTRA: units      "//TRIM(td_var%c_units))
+         CALL logger_trace("VAR GET EXTRA: point      "//TRIM(td_var%c_point))
+         CALL logger_trace("VAR GET EXTRA: interp     "//TRIM(td_var%c_interp(1)))
+         CALL logger_trace("VAR GET EXTRA: filter     "//TRIM(td_var%c_filter(1)))
+         CALL logger_trace("VAR GET EXTRA: min value  "//TRIM(fct_str(td_var%d_min)))
+         CALL logger_trace("VAR GET EXTRA: max value  "//TRIM(fct_str(td_var%d_max)))
          ENDIF
 
@@ -7418,11 +6833,8 @@
    !> 
    !> @details
-   !> minimum value is assume to follow string "min ="
+   !> minimum value is assume to follow sign '>'
    !>
    !> @author J.Paul
-   !> @date November, 2013 - Initial Version
-   !> @date June, 2015 
-   !> - change way to get information in namelist, 
-   !> value follows string "min ="
+   !> - November, 2013- Initial Version
    !
    !> @param[in] cd_name      variable name
@@ -7455,7 +6867,7 @@
       cl_tmp=fct_split(cd_varinfo,ji,';')
       DO WHILE( TRIM(cl_tmp) /= '' )
-         il_ind=INDEX(TRIM(cl_tmp),'min')
+         il_ind=SCAN(TRIM(cl_tmp),'>')
          IF( il_ind /= 0 )THEN
-            cl_min=fct_split(cl_tmp,2,'=')
+            cl_min=TRIM(ADJUSTL(cl_tmp(il_ind+1:)))
             EXIT
          ENDIF
